# - hosts: localhost
#   connection: local
#   become: true
#   vars:
#    region: eu-west-2
#    instance_type: t2.micro
#    ami: ami-0015a39e4b7c0966f # Ubuntu 20.04
#    hosts_file: /etc/ansible/hosts 
#   roles:
#    - aws

 - hosts: webservers
   remote_user: ubuntu
   become: true
   roles:
    - docker
    - kubernetes
 
 - hosts: master
   remote_user: ubuntu
   become: true
   tasks:
    - name: initialize the cluster
      shell: "kubeadm init --pod-network-cidr'='10.244.0.0/16 --ignore-preflight-errors=all"
      args:
       chdir: $HOME
       creates: cluster_initialized.txt

    - name: create .kube directory
      file:
       path: $HOME/.kube
       state: directory
       mode: 0755

    - name: copies admin.conf to user's kube config
      copy:
       src: /etc/kubernetes/admin.conf
       dest: /root/.kube/config
       remote_src: yes
       owner: root

    - name: install Pod network
      shell: kubectl apply -f https://github.com/coreos/flannel/raw/master/Documentation/kube-flannel.yml
      args:
       chdir: $HOME

    - name: Get the token for joining the worker nodes
      shell: kubeadm token create  --print-join-command
      register: kubernetes_join_command

    - name: Copy join command to local file.
      become: yes
      local_action: copy content="{{ kubernetes_join_command.stdout_lines[0] }}" dest="/tmp/kubernetes_join_command" mode=0777
 
 - hosts: slaves
   remote_user: ubuntu
   become: true
   tasks:
    - name: copy join command
      copy:
       src: /tmp/kubernetes_join_command
       dest: /tmp/kubernetes_join_command
       mode: 0777
    - name: join the cluster
      command: sh /tmp/kubernetes_join_command
      register: joined_or_not
